#include "stdafx.h"
#include "TestVersion.h"
#include "TestVersionDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26455)
CTestVersionDlg::CTestVersionDlg(CWnd* pParent) : CDialog(CTestVersionDlg::IDD, pParent),
                                                  m_hIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME))
{
}

void CTestVersionDlg::DoDataExchange(CDataExchange* pDX)
{
  //Let the base class do its thing
  __super::DoDataExchange(pDX);
}

#pragma warning(suppress: 26440 26433)
BEGIN_MESSAGE_MAP(CTestVersionDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_LOAD, &CTestVersionDlg::OnLoad)
END_MESSAGE_MAP()

BOOL CTestVersionDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE); //Set big icon
  SetIcon(m_hIcon, FALSE); //Set small icon
  
  return TRUE;
}

#pragma warning(suppress: 26434)
void CTestVersionDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc(this); //device context for painting

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon = GetSystemMetrics(SM_CXICON);
    const int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    const int x = (rect.Width() - cxIcon + 1) / 2;
    const int y = (rect.Height() - cyIcon + 1) / 2;

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CTestVersionDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

void CTestVersionDlg::OnLoad() 
{
  CVersionInfo info;
  CString sFilename;
  GetDlgItemText(IDC_FILENAME, sFilename);
  
  CString sDetails;
  if (info.Load(sFilename))
  {
    for (int i=0; i<info.GetNumberOfTranslations(); i++)
    {
      const CVersionInfo::TRANSLATION* pTranslation = info.GetTranslation(i);
      info.SetTranslation(i);

      CString sChunk;
      if (i)
#pragma warning(suppress: 26472)
        sChunk.Format(_T("\r\nVersion Info Block, LanguageID:0x%04x, CodePage:%d\r\n"), static_cast<int>(pTranslation->m_wLangID), static_cast<int>(pTranslation->m_wCodePage));
      else
#pragma warning(suppress: 26472)
        sChunk.Format(_T("Version Info Block, LanguageID:0x%04x, CodePage:%d\r\n"), static_cast<int>(pTranslation->m_wLangID), static_cast<int>(pTranslation->m_wCodePage));
      sChunk += GetTranslationDetails(info);
      sDetails += sChunk;
    }    
  }
  else
    sDetails.Format(_T("Failed to load %s, Error:%u"), sFilename.GetString(), GetLastError());

  //Set the text in the edit control to display the details
  SetDlgItemText(IDC_INFO, sDetails);
}

CString CTestVersionDlg::GetTranslationDetails(_In_ const CVersionInfo& info)
{
  CString sDetails;

  //First the fixed version info details
  const VS_FIXEDFILEINFO* pffi = info.GetFixedFileInfo();
  CString sLine;

  //FileVersion
#pragma warning(suppress: 26472)
  sLine.Format(_T("FileVersion: %d.%d.%d.%d (%016I64X)\r\n"), 
               static_cast<int>(HIWORD(pffi->dwFileVersionMS)), static_cast<int>(LOWORD(pffi->dwFileVersionMS)),
               static_cast<int>(HIWORD(pffi->dwFileVersionLS)), static_cast<int>(LOWORD(pffi->dwFileVersionLS)), info.GetFileVersion());
  sDetails += sLine;

  //ProductVersion
#pragma warning(suppress: 26472)
  sLine.Format(_T("ProductVersion: %d.%d.%d.%d (%016I64X)\r\n"), 
               static_cast<int>(HIWORD(pffi->dwProductVersionMS)), static_cast<int>(LOWORD(pffi->dwProductVersionMS)),
               static_cast<int>(HIWORD(pffi->dwProductVersionLS)), static_cast<int>(LOWORD(pffi->dwProductVersionLS)), info.GetProductVersion());
  sDetails += sLine;

  //FileFlags
  const DWORD dwFileFlags = info.GetFileFlags();
  sLine.Format(_T("FileFlags: 0x%04x, "), dwFileFlags);

  //FileFlags (Expanded)
  if (dwFileFlags & VS_FF_DEBUG)
    sLine += _T("VS_FF_DEBUG,");
  if (dwFileFlags & VS_FF_INFOINFERRED)
    sLine += _T("VS_FF_INFOINFERRED,");
  if (dwFileFlags & VS_FF_PATCHED)
    sLine += _T("VS_FF_PATCHED,");
  if (dwFileFlags & VS_FF_PRERELEASE)
    sLine += _T("VS_FF_PRERELEASE,");
  if (dwFileFlags & VS_FF_PRIVATEBUILD)
    sLine += _T("VS_FF_PRIVATEBUILD,");
  if (dwFileFlags & VS_FF_SPECIALBUILD)
    sLine += _T("VS_FF_SPECIALBUILD,");
  sLine  += _T("\r\n");
  sDetails += sLine;

  //OS
  const DWORD dwOS = info.GetOS();
  sLine.Format(_T("OS: 0x%04x, "), dwOS);

  //OS (Expanded)
  if (dwOS & VOS_DOS)
    sLine += _T("VOS_DOS,");
  else if (dwOS & VOS_OS216)
    sLine += _T("VOS_OS216,");
  else if (dwOS & VOS_OS232)
    sLine += _T("VOS_OS232,");
  else if (dwOS & VOS_NT)
    sLine += _T("VOS_NT,");
  else if (dwOS & VOS_WINCE)
    sLine += _T("VOS_WINCE,");
  if (dwOS & VOS__WINDOWS16)
    sLine += _T("VOS__WINDOWS16,");
  if (dwOS & VOS__PM16)
    sLine += _T("VOS__PM16,");
  else if (dwOS & VOS__PM32)
    sLine += _T("VOS__PM32,");
  else if (dwOS & VOS__WINDOWS32)
    sLine += _T("VOS__WINDOWS32,");
  sLine  += _T("\r\n");
  sDetails += sLine;

  //FileType
  const DWORD dwFileType = info.GetFileType();
  sLine.Format(_T("FileType: 0x%04x, "), dwFileType);

  //FileType (Expanded)
  if (dwFileType == VFT_UNKNOWN)
    sLine += _T("Unknown");
  else if (dwFileType == VFT_APP)
    sLine += _T("VFT_APP");
  else if (dwFileType == VFT_DLL)
    sLine += _T("VFT_DLL");
  else if (dwFileType == VFT_DRV)
    sLine += _T("VFT_DRV");
  else if (dwFileType == VFT_FONT)
    sLine += _T("VFT_FONT");
  else if (dwFileType == VFT_VXD)
    sLine += _T("VFT_VXD");
  else if (dwFileType == VFT_STATIC_LIB)
    sLine += _T("VFT_STATIC_LIB");
  sLine  += _T("\r\n");
  sDetails += sLine;

  //FileSubType
  const DWORD dwFileSubType = info.GetFileSubType();
  sLine.Format(_T("FileSubType: 0x%04x "), dwFileSubType);

  //FileSubType (Expanded)
  if (dwFileSubType == VFT2_UNKNOWN)
    sLine += _T("Unknown");
  else if (dwFileSubType == VFT2_DRV_PRINTER)
    sLine += _T("VFT2_DRV_PRINTER");
  else if (dwFileSubType == VFT2_DRV_KEYBOARD)
    sLine += _T("VFT2_DRV_KEYBOARD");
  else if (dwFileSubType == VFT2_DRV_LANGUAGE)
    sLine += _T("VFT2_DRV_LANGUAGE");
  else if (dwFileSubType == VFT2_DRV_DISPLAY)
    sLine += _T("VFT2_DRV_DISPLAY");
  else if (dwFileSubType == VFT2_DRV_MOUSE)
    sLine += _T("VFT2_DRV_MOUSE");
  else if (dwFileSubType == VFT2_DRV_NETWORK)
    sLine += _T("VFT2_DRV_NETWORK");
  else if (dwFileSubType == VFT2_DRV_SYSTEM)
    sLine += _T("VFT2_DRV_SYSTEM");
  else if (dwFileSubType == VFT2_DRV_INSTALLABLE)
    sLine += _T("VFT2_DRV_INSTALLABLE");
  else if (dwFileSubType == VFT2_DRV_SOUND)
    sLine += _T("VFT2_DRV_SOUND");
  else if (dwFileSubType == VFT2_DRV_COMM)
    sLine += _T("VFT2_DRV_COMM");
  sLine  += _T("\r\n");
  sDetails += sLine;

  //Creation Date
  const FILETIME ft = info.GetCreationTime();
  const COleDateTime t(ft);
  sLine.Format(_T("CreationDate: %s\r\n"), t.Format().GetString());
  sDetails += sLine;

  //Comments
  sLine.Format(_T("Comments: %s\r\n"), info.GetComments().c_str());
  sDetails += sLine;

  //CompanyName
  sLine.Format(_T("CompanyName: %s\r\n"), info.GetCompanyName().c_str());
  sDetails += sLine;

  //FileDescription
  sLine.Format(_T("FileDescription: %s\r\n"), info.GetFileDescription().c_str());
  sDetails += sLine;

  //FileVersion (string)
  sLine.Format(_T("FileVersion (string): %s\r\n"), info.GetFileVersionAsString().c_str());
  sDetails += sLine;

  //InternalName
  sLine.Format(_T("InternalName: %s\r\n"), info.GetInternalName().c_str());
  sDetails += sLine;

  //LegalCopyright
  sLine.Format(_T("LegalCopyright: %s\r\n"), info.GetLegalCopyright().c_str());
  sDetails += sLine;

  //LegalTrademarks
  sLine.Format(_T("LegalTrademarks: %s\r\n"), info.GetLegalTrademarks().c_str());
  sDetails += sLine;

  //OriginalFilename
  sLine.Format(_T("OriginalFilename: %s\r\n"), info.GetOriginalFilename().c_str());
  sDetails += sLine;

  //PrivateBuild
  sLine.Format(_T("PrivateBuild: %s\r\n"), info.GetPrivateBuild().c_str());
  sDetails += sLine;

  //ProductName
  sLine.Format(_T("ProductName: %s\r\n"), info.GetProductName().c_str());
  sDetails += sLine;

  //ProductVersion (string)
  sLine.Format(_T("ProductVersion (string): %s\r\n"), info.GetProductVersionAsString().c_str());
  sDetails += sLine;

  //SpecialBuild
  sLine.Format(_T("SpecialBuild: %s\r\n"), info.GetSpecialBuild().c_str());
  sDetails += sLine;

  return sDetails;
}